# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ProjectIdApplicationdeploymentsBody(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'git_url': 'str',
        'git_branch': 'str',
        'type': 'str',
        'broker': 'str',
        'app_cpu': 'float',
        'app_ram': 'str',
        'app_replica_count': 'float',
        'env_vars': 'str',
        'access_type': 'str',
        'description': 'str'
    }

    attribute_map = {
        'name': 'name',
        'git_url': 'git_url',
        'git_branch': 'git_branch',
        'type': 'type',
        'broker': 'broker',
        'app_cpu': 'app_cpu',
        'app_ram': 'app_ram',
        'app_replica_count': 'app_replica_count',
        'env_vars': 'env_vars',
        'access_type': 'access_type',
        'description': 'description'
    }

    def __init__(self, name=None, git_url=None, git_branch=None, type=None, broker=None, app_cpu=None, app_ram=None, app_replica_count=None, env_vars=None, access_type=None, description=None):  # noqa: E501
        """ProjectIdApplicationdeploymentsBody - a model defined in Swagger"""  # noqa: E501
        self._name = None
        self._git_url = None
        self._git_branch = None
        self._type = None
        self._broker = None
        self._app_cpu = None
        self._app_ram = None
        self._app_replica_count = None
        self._env_vars = None
        self._access_type = None
        self._description = None
        self.discriminator = None
        if name is not None:
            self.name = name
        if git_url is not None:
            self.git_url = git_url
        if git_branch is not None:
            self.git_branch = git_branch
        if type is not None:
            self.type = type
        if broker is not None:
            self.broker = broker
        if app_cpu is not None:
            self.app_cpu = app_cpu
        if app_ram is not None:
            self.app_ram = app_ram
        if app_replica_count is not None:
            self.app_replica_count = app_replica_count
        if env_vars is not None:
            self.env_vars = env_vars
        if access_type is not None:
            self.access_type = access_type
        if description is not None:
            self.description = description

    @property
    def name(self):
        """Gets the name of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The name of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ProjectIdApplicationdeploymentsBody.


        :param name: The name of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def git_url(self):
        """Gets the git_url of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The git_url of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._git_url

    @git_url.setter
    def git_url(self, git_url):
        """Sets the git_url of this ProjectIdApplicationdeploymentsBody.


        :param git_url: The git_url of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: str
        """

        self._git_url = git_url

    @property
    def git_branch(self):
        """Gets the git_branch of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The git_branch of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._git_branch

    @git_branch.setter
    def git_branch(self, git_branch):
        """Sets the git_branch of this ProjectIdApplicationdeploymentsBody.


        :param git_branch: The git_branch of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: str
        """

        self._git_branch = git_branch

    @property
    def type(self):
        """Gets the type of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The type of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this ProjectIdApplicationdeploymentsBody.


        :param type: The type of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["r", "python", "node"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    @property
    def broker(self):
        """Gets the broker of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The broker of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._broker

    @broker.setter
    def broker(self, broker):
        """Sets the broker of this ProjectIdApplicationdeploymentsBody.


        :param broker: The broker of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: str
        """

        self._broker = broker

    @property
    def app_cpu(self):
        """Gets the app_cpu of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The app_cpu of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: float
        """
        return self._app_cpu

    @app_cpu.setter
    def app_cpu(self, app_cpu):
        """Sets the app_cpu of this ProjectIdApplicationdeploymentsBody.


        :param app_cpu: The app_cpu of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: float
        """
        allowed_values = [1, 2, 4]  # noqa: E501
        if app_cpu not in allowed_values:
            raise ValueError(
                "Invalid value for `app_cpu` ({0}), must be one of {1}"  # noqa: E501
                .format(app_cpu, allowed_values)
            )

        self._app_cpu = app_cpu

    @property
    def app_ram(self):
        """Gets the app_ram of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The app_ram of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._app_ram

    @app_ram.setter
    def app_ram(self, app_ram):
        """Sets the app_ram of this ProjectIdApplicationdeploymentsBody.


        :param app_ram: The app_ram of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["128Mi", "256Mi", "512Mi", "1Gi", "2Gi", "4Gi", "8Gi"]  # noqa: E501
        if app_ram not in allowed_values:
            raise ValueError(
                "Invalid value for `app_ram` ({0}), must be one of {1}"  # noqa: E501
                .format(app_ram, allowed_values)
            )

        self._app_ram = app_ram

    @property
    def app_replica_count(self):
        """Gets the app_replica_count of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The app_replica_count of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: float
        """
        return self._app_replica_count

    @app_replica_count.setter
    def app_replica_count(self, app_replica_count):
        """Sets the app_replica_count of this ProjectIdApplicationdeploymentsBody.


        :param app_replica_count: The app_replica_count of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: float
        """
        allowed_values = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10]  # noqa: E501
        if app_replica_count not in allowed_values:
            raise ValueError(
                "Invalid value for `app_replica_count` ({0}), must be one of {1}"  # noqa: E501
                .format(app_replica_count, allowed_values)
            )

        self._app_replica_count = app_replica_count

    @property
    def env_vars(self):
        """Gets the env_vars of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The env_vars of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._env_vars

    @env_vars.setter
    def env_vars(self, env_vars):
        """Sets the env_vars of this ProjectIdApplicationdeploymentsBody.


        :param env_vars: The env_vars of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: str
        """

        self._env_vars = env_vars

    @property
    def access_type(self):
        """Gets the access_type of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The access_type of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._access_type

    @access_type.setter
    def access_type(self, access_type):
        """Sets the access_type of this ProjectIdApplicationdeploymentsBody.


        :param access_type: The access_type of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: str
        """
        allowed_values = ["public", "fine_grained"]  # noqa: E501
        if access_type not in allowed_values:
            raise ValueError(
                "Invalid value for `access_type` ({0}), must be one of {1}"  # noqa: E501
                .format(access_type, allowed_values)
            )

        self._access_type = access_type

    @property
    def description(self):
        """Gets the description of this ProjectIdApplicationdeploymentsBody.  # noqa: E501


        :return: The description of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ProjectIdApplicationdeploymentsBody.


        :param description: The description of this ProjectIdApplicationdeploymentsBody.  # noqa: E501
        :type: str
        """

        self._description = description

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ProjectIdApplicationdeploymentsBody, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProjectIdApplicationdeploymentsBody):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
